VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   ""
   ClientHeight    =   6120
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7500
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   6120
   ScaleWidth      =   7500
   StartUpPosition =   2  'CenterScreen
   Begin VB.Timer Timer1 
      Interval        =   250
      Left            =   6840
      Top             =   120
   End
   Begin VB.PictureBox Pic 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00004000&
      FillColor       =   &H00FF8080&
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   204
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H0000C000&
      Height          =   5895
      Left            =   120
      ScaleHeight     =   5835
      ScaleWidth      =   7155
      TabIndex        =   0
      Top             =   120
      Width           =   7215
   End
   Begin VB.Label Label2 
      Caption         =   "    :"
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   4680
      Width           =   6495
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Created by SCINER: lenar2003@mail.ru

Private Const MAX_INTERFACE_NAME_LEN  As Long = 256
Private Const ERROR_SUCCESS   As Long = 0
Private Const MAXLEN_IFDESCR    As Long = 256
Private Const MAXLEN_PHYSADDR   As Long = 8

Private Const MIB_IF_OPER_STATUS_NON_OPERATIONAL As Long = 0
Private Const MIB_IF_OPER_STATUS_UNREACHABLE     As Long = 1
Private Const MIB_IF_OPER_STATUS_DISCONNECTED    As Long = 2
Private Const MIB_IF_OPER_STATUS_CONNECTING      As Long = 3
Private Const MIB_IF_OPER_STATUS_CONNECTED       As Long = 4
Private Const MIB_IF_OPER_STATUS_OPERATIONAL     As Long = 5

Private Const MIB_IF_TYPE_OTHER       As Long = 1
Private Const MIB_IF_TYPE_ETHERNET    As Long = 6
Private Const MIB_IF_TYPE_TOKENRING   As Long = 9
Private Const MIB_IF_TYPE_FDDI        As Long = 15
Private Const MIB_IF_TYPE_PPP         As Long = 23
Private Const MIB_IF_TYPE_LOOPBACK    As Long = 24
Private Const MIB_IF_TYPE_SLIP        As Long = 28

Private Const MIB_IF_ADMIN_STATUS_UP        As Long = 1
Private Const MIB_IF_ADMIN_STATUS_DOWN      As Long = 2
Private Const MIB_IF_ADMIN_STATUS_TESTING   As Long = 3
   
Private Type MIB_IFROW
   wszName(0 To (MAX_INTERFACE_NAME_LEN - 1) * 2) As Byte
   dwIndex              As Long
   dwType               As Long
   dwMtu                As Long
   dwSpeed              As Long
   dwPhysAddrLen        As Long
   bPhysAddr(0 To MAXLEN_PHYSADDR - 1) As Byte
   dwAdminStatus        As Long
   dwOperStatus         As Long
   dwLastChange         As Long
   dwInOctets           As Long
   dwInUcastPkts        As Long
   dwInNUcastPkts       As Long
   dwInDiscards         As Long
   dwInErrors           As Long
   dwInUnknownProtos    As Long
   dwOutOctets          As Long
   dwOutUcastPkts       As Long
   dwOutNUcastPkts      As Long
   dwOutDiscards        As Long
   dwOutErrors          As Long
   dwOutQLen            As Long
   dwDescrLen           As Long
   bDescr(0 To MAXLEN_IFDESCR - 1) As Byte

End Type
   
Private Declare Function GetIfTable Lib "iphlpapi.dll" (ByRef pIfTable As Any, ByRef pdwSize As Long, ByVal bOrder As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDst As Any, pSrc As Any, ByVal ByteLen As Long)
Private Declare Function inet_ntoa Lib "wsock32" (ByVal addr As Long) As Long
Private Declare Function lstrcpyA Lib "kernel32" (ByVal RetVal As String, ByVal Ptr As Long) As Long
Private Declare Function lstrlenA Lib "kernel32" (ByVal Ptr As Any) As Long
Private Declare Function GetFriendlyIfIndex Lib "iphlpapi" (ByVal IfIndex As Long) As Long

Private Sub Form_Load()
  Call Timer1_Timer
End Sub

Private Sub Timer1_Timer()

   Dim IPInterfaceRow As MIB_IFROW
   Dim buff() As Byte
   Dim cbRequired As Long
   Dim nStructSize As Long
   Dim nRows As Long
   Dim i As Long

   Call GetIfTable(ByVal 0&, cbRequired, 1)

   Pic.Cls
   If cbRequired > 0 Then
      ReDim buff(0 To cbRequired - 1) As Byte
      If GetIfTable(buff(0), cbRequired, 1) = ERROR_SUCCESS Then
         nStructSize = LenB(IPInterfaceRow)
         CopyMemory nRows, buff(0), 4
         For i = 1 To nRows
            CopyMemory IPInterfaceRow, buff(4 + (i - 1) * nStructSize), nStructSize
            Pic.Print ":        " & GetConnectType(IPInterfaceRow.dwType)
            Pic.Print ":     " & GetConnectStatus(IPInterfaceRow.dwOperStatus)
            Pic.Print ":   " & (IPInterfaceRow.dwInOctets \ 1000) & " "
            Pic.Print ":  " & (IPInterfaceRow.dwOutOctets \ 1000) & " "
            Pic.Print ":   " & (IPInterfaceRow.dwSpeed \ 1000) & " /"
            Pic.Print String(256, "-")
          Next
      End If
    End If
  
End Sub

Function GetConnectType(ByVal index As Long) As String
  Select Case index
  Case MIB_IF_TYPE_OTHER: GetConnectType = "OTHER"
  Case MIB_IF_TYPE_ETHERNET: GetConnectType = "ETHERNET"
  Case MIB_IF_TYPE_TOKENRING: GetConnectType = "TOKENRING"
  Case MIB_IF_TYPE_FDDI: GetConnectType = "FDDI"
  Case MIB_IF_TYPE_PPP: GetConnectType = "PPP"
  Case MIB_IF_TYPE_LOOPBACK: GetConnectType = "LOOPBACK"
  Case MIB_IF_TYPE_SLIP: GetConnectType = "SLIP"
  Case Else
  End Select
End Function


Function GetConnectStatus(ByVal index As Long) As String
  Select Case index
  Case MIB_IF_OPER_STATUS_NON_OPERATIONAL: GetConnectStatus = "NON_OPERATIONAL"
  Case MIB_IF_OPER_STATUS_UNREACHABLE: GetConnectStatus = "UNREACHABLE"
  Case MIB_IF_OPER_STATUS_DISCONNECTED: GetConnectStatus = "DISCONNECTED"
  Case MIB_IF_OPER_STATUS_CONNECTING: GetConnectStatus = "CONNECTING"
  Case MIB_IF_OPER_STATUS_CONNECTED: GetConnectStatus = "CONNECTED"
  Case MIB_IF_OPER_STATUS_OPERATIONAL: GetConnectStatus = "OPERATIONAL"
  Case Else
  End Select
End Function
